package x36paa_batoh_5;

import java.util.*;

/**
 * <p>Title: </p>
 *
 * <p>Description: </p>
 *
 * <p>Copyright: Copyright (c) 2005</p>
 *
 * <p>Company: </p>
 *
 * @author not attributable
 * @version 1.0
 */
class MethodOfBranchsAndBorders extends MethodInterface {
  //Metoda vtv a hranic

  private Input input;

  private int maxWeigth, hMin;

  public MethodOfBranchsAndBorders() {
  }

  public MethodInterface newInstance() {
    return new MethodOfBranchsAndBorders();
  }

  public Output calc(Input in) {
    long time=System.nanoTime(),opers=0;
    this.input=in;
    PriorList<State> priorList=new PriorList<State>();
    maxWeigth=in.getMaxWeight();
    hMin=0;
    State out=new State();
    priorList.add(out);
    while (priorList.size()>0) {
      opers++;
//      System.out.println(priorList.toString());
      State state=priorList.get();
      List<State> add=state.getNext(hMin);
      for (State s:add) priorList.add(s);
      for (State s:add) {
        if (s.isFinal()) {
          if ((state.h=state.getH())>hMin) {
            hMin=state.h;
            priorList.removeAfter(state);
            out=state;
          }
        }
      }
    }
    return new Output(input, out.items,System.nanoTime()-time,opers);
  }

  class State implements Comparable {
    List<Item> items=new LinkedList<Item>();
    int position=-1, h=getH();

    public int getH() {
    /*  int */h=0;
      for (Item item:items) h+=item.getPrice();
      for (int i=position+1;i<input.size();i++) {
        h+=((Item) input.get(i)).getPrice();
      }
      return h;
    }

    public int getWeigth() {
      int out=0;
      for (Item item:items) out+=item.getWeigth();
      return out;
    }

    public boolean isFinal() {
      return position==input.size();
    }

    public List<State> getNext(int hMin) {
      List<State> out=new LinkedList<State>();
      for (int i=0;i<2;i++) {
        State s=new State();
        if (this.position+1<input.size()) {
          s.items.addAll(items);
          s.position=this.position+1;
          if (i>0) {
            s.items.add((Item) input.get(s.position));
            s.h=s.getH();
            if ((s.getWeigth()<=maxWeigth) && (s.h>=hMin)) out.add(s);
          } else {
            if ((s.getWeigth()<=maxWeigth) && ((s.h=s.getH())>=hMin)) {
              out.add(s);
            }
          }
        } else if (this.position<input.size()) {
          s.items.addAll(items);
          s.position=this.position+1;
          if ((s.getWeigth()<=maxWeigth) && ((s.h=s.getH())>=hMin)) {
            out.add(s);
          }
        }
      }
      return out;
    }

    public int compareTo(Object o) {
      return ((State) o).h-h;
    }
  }
}
