package x36paa_batoh_5;

import java.util.*;


/**
 * <p>Title: </p>
 *
 * <p>Description: </p>
 *
 * <p>Copyright: Copyright (c) 2005</p>
 *
 * <p>Company: </p>
 *
 * @author not attributable
 * @version 1.0
 */
class Output implements Comparable {

  private Input input;
  private List<Item> inserted;
  private long time, opers;

  public Output(Input input, List<Item> inserted,long time,long opers) {
    this.input=input;
    this.opers=opers;
    this.inserted=inserted;
    this.time=time;
  }

  public Output(Input input, List<Item> inserted) {
    this.input=input;
    this.inserted=inserted;
  }

  public int getPrice() {
    int out=0;
    for (Item item:inserted) {
      out+=item.getPrice();
    }
    return out;
  }

  public int getWeigth() {
    int out=0;
    for (Item item:inserted) {
      out+=item.getWeigth();
    }
    return out;
  }

  public int size() {
    return inserted.size();
  }

  public List<Item> getInsertedItems() {
    return inserted;
  }

  public boolean[] getVector() {
    boolean out[]=new boolean[input.size()];
    int i=0;
    for (Iterator iterator=input.iterator();iterator.hasNext();) {
      if (inserted.contains(iterator.next())) out[i]=true;
      i++;
    }
    return out;
  }

  public String getVectorString() {
    boolean array[]=getVector(), start=true;
    String out=new String();
    for (Boolean b : array) {
      if (start) start=false; else out+=", ";
      out+=b?"1":"0";
    }
    return "[" + out + "]";
  }

  public String getInsertedItemsString() {
    boolean start=true;
    String out=new String();
    for (Item item:inserted) {
      if (start) start=false; else out+=", ";
      out+=item.getName();
    }
    return out;
  }

  public long getTime() {
    return time;
  }

  public long getCountOfOperations() {
    return opers;
  }

  public void setTime(long time) {
    this.time=time;
  }

  public void setCountOfOperations(long opers) {
    this.opers=opers;
  }

  public void add(Item item) {
    inserted.add(item);
  }

  public Item get(int i) {
    return inserted.get(i);
  }

  public void remove(int i) {
    inserted.remove(i);
  }

  public boolean contains(Item i) {
    return inserted.contains(i);
  }

  public Output clone() {
    Output out=new Output(input,new LinkedList<Item>(),time,opers);
    for (Item item:inserted) out.add(item);
    return out;
  }

  public int compareTo(Object o) {
    return ((Output) o).getPrice()-getPrice();
  }
}
