package x36paa_batoh_5;

import java.util.*;

/**
 * <p>Title: </p>
 *
 * <p>Description: </p>
 *
 * <p>Copyright: Copyright (c) 2005</p>
 *
 * <p>Company: </p>
 *
 * @author not attributable
 * @version 1.0
 */
class Ant extends MethodInterface {

  private final int COUNT_OF_ANT_PER_ITEM        = 2;
  private final int COUNT_OF_TEST_WITHOUT_BETTER = 20;

  private long opers;
  private Output out;

  private Input input;

  private ItemExtended[] items;
  private double[] pheromones;

  private int maxWeigth;

  public Ant() {
  }

  public MethodInterface newInstance() {
    return new Ant();
  }

  private double max() {
    double out=0.;
    for (double d:pheromones)
      if (d>out) out=d;
    return out;
  }

  private double sum() {
    double out=0.;
    for (double d:pheromones) out+=d;
    return out;
  }


  private void go() {
    int counter=0;
    int maxPrice=0;
    for (Item item:items) maxPrice+=item.getPrice();
    Random rnd=new Random();
    while (counter<COUNT_OF_TEST_WITHOUT_BETTER) { // pocet pokusu bey lepsiho vysledku
      Output[] ants=new Output[COUNT_OF_ANT_PER_ITEM*items.length]; // pocet mravencu
      for (int i=0;i<ants.length;i++) ants[i]=new Output(input,new LinkedList());
      for (int i=0;i<items.length;i++) items[i].setPheromone(pheromones[i]);
      double sum=sum(),max=max();
      counter++;
      for (Output ant:ants) {
//        System.out.print(".");
        opers++;
        for (int i=0;i<items.length;i++) {
          if (rnd.nextDouble()*Math.max(max*1.25,1.25*sum/items.length)<pheromones[i]) {
            ant.add(items[i]);
          }
        }
        while (ant.getWeigth()>maxWeigth) {
          ant.remove(Math.abs(rnd.nextInt())%ant.size());
//          System.out.print("x");
        }
        /*
        Collections.sort(ant.getInsertedItems());
        while (ant.getWeigth()>maxWeigth) {
          for (int i=0;i<ant.size();i++) {
            if (rnd.nextDouble()<1./ant.size()) {
              ant.remove(0);
//              System.out.print("x");
            }
          }
        }*/
        if (ant.getPrice()>out.getPrice()) {
          out=ant;
//          System.out.println(ant.getPrice());
          counter=0;
        }
      }
      for (int i=0;i<pheromones.length;i++) pheromones[i]*=0.75; // stopa vyyichv
      for (Output ant:ants) {
        double pheromone=((double) ant.getPrice())/((double) maxPrice);
        for (int i=0;i<pheromones.length;i++)
          if (ant.contains(items[i])) pheromones[i]+=pheromone;
      }
    }
//    System.out.println("\n" + out.getPrice());
  }

  public Output calc(Input in) {
    opers=0;
    maxWeigth=in.getMaxWeight();
    input=in;
    out=new Output(in, new LinkedList());
    items=new ItemExtended[in.size()];
    pheromones=new double[in.size()];
    for (int i=0;i<items.length;i++) {
      items[i]=new ItemExtended(in.get(i));
      pheromones[i]=1.;
    }
    long time=System.nanoTime();
    go();
    out.setTime(System.nanoTime()-time);
    out.setCountOfOperations(opers);
    return out;
  }
}
