package x36paa_batoh_5;

import java.util.*;

/**
 * <p>Title: </p>
 *
 * <p>Description: </p>
 *
 * <p>Copyright: Copyright (c) 2005</p>
 *
 * <p>Company: </p>
 *
 * @author not attributable
 * @version 1.0
 */
class Genetic extends MethodInterface {

  private Random rnd=new Random();

  private long opers;
  private Output out;
  private Input in;

  private PriorList<Output> list=new PriorList<Output>();

  public Genetic() {
  }

  public MethodInterface newInstance() {
    return new Genetic();
  }

  public Output calc(Input in) {
    opers=0;
    this.in=in;
    out=new Output(in,new LinkedList<Item>());
    long time=System.nanoTime();
    generateFirstGeneration();
    go();
    out.setTime(System.nanoTime()-time);
    out.setCountOfOperations(opers);
    return out;
  }

  private void generateFirstGeneration() {
    boolean exist=false;
    for (int i=0;i<in.size();i++) if (in.get(i).getWeigth()<=in.getMaxWeight()) exist=true;
    for (int i=0;i<20;i++) { // 20 na zacatku
      opers++;
      Output a=new Output(in,new LinkedList<Item>());
      while (a.size()<in.size()) {
        Item item=in.get(Math.abs(rnd.nextInt())%in.size());
        if (!a.contains(item)) {
          if (item.getWeigth()+a.getWeigth()>in.getMaxWeight()) {
            if (a.size()>0) break;
            if (exist) continue;
            break;
          }
          a.add(item);
        }
      }
      list.add(a);
    }
  }

  private void go() {
    long counter=0;
    while (counter<10) {
      int priceBefor=out.getPrice();
      PriorList<Output> list2=new PriorList<Output>();
      grade(list2);
      mutate(list2);
      for (int i=0;i<10;i++) list2.add(list.get());
      list2.breakFirst(32);
      list=list2;
      Output o=(Output) list.read(0);
      if (o.getPrice()>out.getPrice()) out=o;
      if (priceBefor!=out.getPrice()) {
        counter=0;
      } else counter++;
    }
  }

  private Output grade(Output a, Output b) {
    Output out=new Output(in,new LinkedList<Item>());
    List<Item> spec=new LinkedList<Item>();
    for (int i=0;i<a.size();i++) {
      if (b.contains(a.get(i))) {
        out.add(a.get(i));
      } else spec.add(a.get(i));
    }
    for (int i=0;i<b.size();i++) {
      if (!a.contains(b.get(i))) spec.add(b.get(i));
    }
    while (spec.size()>0) {
      int i=Math.abs(rnd.nextInt())%spec.size();
      if (out.getWeigth()+spec.get(i).getWeigth()<=in.getMaxWeight()) {
        out.add(spec.get(i));
      }
      spec.remove(i);
    }
    return out;
  }

  private void grade(PriorList list2) {
    for (int i=0;i<list.size();i++) {
      for (int j=0;j<1;j++) {
        opers++;
        int second=Math.abs(rnd.nextInt())%list.size();
        list2.add(grade((Output) list.read(i),(Output) list.read(second)));
      }
    }
  }

  private void mutate(PriorList list2) {
    for (int i=0;i<list.size();i++) {
      Output out=((Output) list.read(i)).clone();
      Item item=in.get(Math.abs(rnd.nextInt())%in.size());
      if (!out.contains(item)) {
        if (item.getWeigth()<=in.getMaxWeight()) {
          opers++;
          while (out.getWeigth()+item.getWeigth()>in.getMaxWeight()) {
            out.remove(Math.abs(rnd.nextInt())%out.size());
          }
          out.add(item);
          list2.add(out);
        }
      }
    }
  }
}
